/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "primitive.h"

scripterreturn_t _scriptPrimitiveDraw(scriptercontext_t *context) {
  primitive_t *primitive = duk_to_pointer(context, 0);
  int32_t start = duk_to_number(context, 1);
  int32_t count = duk_to_number(context, 2);
  primitiveDraw(primitive, start, count);
  return 0;
}

scripterreturn_t _scriptCubeInit(scriptercontext_t *context) {
  primitive_t *primitive = malloc(sizeof(primitive_t));
  cubeInit(primitive, 1, 1, 1);
  duk_push_pointer(context, primitive);
  return 1;
}

void scriptsApiPrimitive(scripter_t *scripter) {
  scripterDefineMethod(scripter,
    SCRIPT_PRIMITIVE_DRAW_NAME,
    SCRIPT_PRIMITIVE_DRAW_ARGS,
    &_scriptPrimitiveDraw
  );
  scripterDefineMethod(scripter,
    SCRIPT_CUBE_INIT_NAME,
    SCRIPT_CUBE_INIT_ARGS,
    &_scriptCubeInit
  );
}